/**
 * This router handles things related to the web browser experience...
 */
const express = require('express')
var db = require('machankura.db')
const { Op } = require("sequelize")
const passport = require('passport')
const config = require('config')
const domain = config.get("server.domain");

const supportedRedirects = [
    new RegExp("^/receive/$"),
    new RegExp("^/send/$")
]

module.exports = function () {
    var router = express.Router();

    router.route('/')
        .get(async function (request, response, next) {
            return response.redirect("/dashboard")
        })
    
    router.route('/logout')
        .post(function (request, response, next) {
            if (request.platform) {
                request.logout(function () {

                });
                // db.Session.destroy({
                //     where: {
                //         sid: request.sessionID
                //     }
                // }).then(result => {
                    
                //     response.redirect('/');
                // }).catch(error => {
                //     response.redirect('/');
                //     logger.error(`${response.getHeader("id")} - Log out error: `, error);
                // })
                response.json({
                    status: "OK",
                    data: "Logout"
                });
            } else {
                next()
            }
        })

    // var creationRouter = require('./creation/')();
    // var passwordResetRouter = require('./password-reset')();

    // var authenticateRouter = require('./authenticate/')();
    // router.use('/authenticate', authenticateRouter);

    return router;
};