/**
 * This router handles things related to the web browser experience...
 */
const express = require('express')
var db = require('machankura.db')
const exchangeRate = require("machankura.exchange-rate")

module.exports = function () {
    var router = express.Router();

    router.route('/availability/:name')
        .get(async function (request, response, next) {
            if (request.platform) {
                const existingName = await db.Name.findOne({
                    where: {
                        text: request.params.name
                    }
                }).catch(error => {
                    return null
                })

                if (existingName) {
                    response.json({
                        data: false
                    })
                } else {
                    const name = await  db.Name.build({
                        text: request.params.name
                    }).validate().catch(error => {
                        return null
                    })

                    response.json({
                        data: name != null
                    }) 
                }
                               
            } else {
                response.status(401)
                response.json({
                    status: "error",
                    message: "Unauthorized"
                })
            }
        })

    router.route('/existence/:name')
        .get(async function (request, response, next) {
            if (request.platform) {
                const existingName = await db.Name.findOne({
                    where: {
                        text: request.params.name
                    }
                }).catch(error => {
                    return null
                })

                response.json({
                    data: existingName != null
                })
                               
            } else {
                response.status(401)
                response.json({
                    status: "error",
                    message: "Unauthorized"
                })
            }
        })

    return router;
};