/**
 * This router handles things related to the web browser experience...
 */
const express = require('express')
var db = require('machankura.db')

module.exports = function () {
    var router = express.Router();

    router.use(async (request, response, next) => {
        if (request.platform) {
            console.log("Base URL: ", request.baseUrl)
            console.log("Original URL: ", request.originalUrl)

            request.originalUrl = request.originalUrl.at(-1) == "/" ? request.originalUrl.slice(0,-1) : request.originalUrl
            const userId = request.baseUrl.split("/").at(-1);

            console.log("UserID: ", userId)
            // TODO: Find user...
            const user = await db.User.findByPk(userId, {
                include: [
                    {
                        association: db.User.UserRoles,
                        include: {
                            model: db.Role,
                            attributes: ['type'],
                        }
                    },
                    {
                        association: db.User.UserPhones,
                        include: [
                            {
                                association: db.UserPhone.Phone
                            }
                        ]
                    },
                    {
                        association: db.User.UserWallet,
                        include: [
                            {
                                association: db.UserWallet.Wallet
                            }
                        ]
                    }
                ]
            })
            if (user) {
                request.user = user

                next()
                // if (user.clanRoot.clanActionPolicy || request.path == "/settings/policy") {
                //     next();
                // } else {
                //     response.redirect(`/clans/${user.clanRoot.id}/settings/policy`);
                // }
            } else {
                response.status(404)
                response.json({
                    status: "error",
                    message: "Clan not found"
                })
            }
        } else {
            response.status(401)
            response.json({
                status: "error",
                message: "Unauthorized"
            })
        }
    })

    // router.route('/')
    //     .get(async function (request, response, next) {
    //         if (request.platform) {
    //             response.json({
    //                 data: request.platform
    //             });
    //         } else {
    //             response.redirect('/account/authenticate')
    //         }
    //     })

    const walletRouter = require('./wallet')();

    router.use('/wallet', walletRouter);

    return router;
};