const config = require('config');
const express = require('express');
const bodyParser = require("body-parser");

module.exports = function () {
    var server = {}; 

    server.run = (db) => {
        console.log("Starting Server")
        return new Promise(async (resolve, reject) => {
            const app = express();
            
            app.use(bodyParser.urlencoded({ extended: true }));
            app.use(bodyParser.json());
            
            app.use('/static', express.static("server/static"));
            
            // TODO: check that user has an individualEntityUser....
            var router = require('./router/index.js')({
                app: app,
                express: express,
                db: db
            });
            app.use('/v1/', router);
            

            // TODO: Handle authentication and confirm this isn't being spoofed
            
            const port = process.env.PORT || config.get("server.port");

            app.listen(port);
            resolve(port);
        });
    }
    
    return server;
};